#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <sys/ioctl.h>
#include <sys/mount.h>

#include "devices/mtd.h"

int main(int argc,char *argv[])
{
   struct mtd_info meminfo;
   int Fd;
   unsigned long Length;
   
   if (1 >= argc)
   {
      fprintf(stderr,"You must specify a device\n");
      return 16;
   }
   
   // Open and size the device
   if ((Fd = open(argv[1],O_RDWR)) < 0)
   {
      fprintf(stderr,"File open error\n");
      return 8;
   }
   
   if (ioctl(Fd,BLKGETSIZE,&Length) < 0)
   {
      perror("ioctl BLKGETSIZE");
      return 9;
   }
   else
      Length *= 512;
   
   if (ioctl(Fd,MEMGETINFO,&meminfo) == 0)
   {
      struct erase_info erase;
      
      erase.length = Length;
      if (argc >= 2)
	 erase.length = atoi(argv[2]);
      erase.start = 0;
      
      printf("Performing Flash Erase %lu",erase.length);
      fflush(stdout);
      
      if (ioctl(Fd,MEMERASE,&erase) != 0)
      {      
	 perror("\nMTD Erase failure");
	 close(Fd);
	 return 8;
      }
      printf(" done\n");
   }
   
   return 0;
}
